Package: org.codehaus.groovy.classgen.asm

## [Java] Class CompileStack

- org.codehaus.groovy.classgen.asm.CompileStack

- All Implemented Interfaces and Traits:
    org.objectweb.asm.Opcodes

      public class CompileStack
      extends Object

  This class is a helper for AsmClassGenerator. It manages different aspects of the code of a code block like handling labels, defining variables, and scopes. After a MethodNode is visited clear should be called, for initialization the method init should be used.

  Some Notes:

  - every push method will require a later pop call
  - method parameters may define a category 2 variable, so don't ignore the type stored in the variable object
  - the index of the variable may not be as assumed when the variable is a parameter of a method because the parameter may be used in a closure, so don't ignore the stored variable index
  - the names of temporary variables can be ignored. The names are only used for debugging and do not conflict with each other or normal variables. For accessing, the index of the variable must be used.
  - never mix temporary and normal variables by changes to this class. While the name is very important for a normal variable, it is only a helper construct for temporary variables. That means for example a name for a temporary variable can be used multiple times without conflict. So mixing them both may lead to the problem that a normal or temporary variable is hidden or even removed. That must not happen!
  See Also:
    AsmClassGenerator

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `static class` | `CompileStack.BlockRecorder` |
    `protected static class` | `CompileStack.LabelRange` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `def` | `CompileStack(WriterController wc)`
    `` | `void` | `addExceptionBlock(org.objectweb.asm.Label start, org.objectweb.asm.Label end, org.objectweb.asm.Label goal, String sig)`
    `` | `void` | `applyBlockRecorder()`
    `` | `void` | `applyFinallyBlocks(org.objectweb.asm.Label label, boolean isBreakLabel)`
    `` | `void` | `clear()` Clears the state of the class.
    `` | `boolean` | `containsVariable(String name)` @param name the name of the variable of interest
    `` | `org.objectweb.asm.Label` | `createLocalLabel(String name)` creates a new named label
    `` | `int` | `defineTemporaryVariable(Variable var, boolean store)` creates a temporary variable.
    `` | `int` | `defineTemporaryVariable(String name, boolean store)` creates a temporary variable.
    `` | `int` | `defineTemporaryVariable(String name, ClassNode node, boolean store)` creates a temporary variable.
    `` | `BytecodeVariable` | `defineVariable(Variable v, boolean initFromStack)` Defines a new Variable using an AST variable.
    `` | `BytecodeVariable` | `defineVariable(Variable v, ClassNode variableType, boolean initFromStack)`
    `` | `org.objectweb.asm.Label` | `getBreakLabel()`
    `` | `org.objectweb.asm.Label` | `getContinueLabel()`
    `` | `org.objectweb.asm.Label` | `getLabel(String name)` Returns the label for the given name
    `` | `org.objectweb.asm.Label` | `getNamedBreakLabel(String name)` Used for `break foo` inside a loop to end the execution of the marked loop.
    `` | `org.objectweb.asm.Label` | `getNamedContinueLabel(String name)` Used for `continue foo` inside a loop to continue the execution of the marked loop.
    `` | `VariableScope` | `getScope()`
    `` | `BytecodeVariable` | `getVariable(String variableName)`
    `` | `BytecodeVariable` | `getVariable(String variableName, boolean mustExist)` Returns a normal variable.
    `` | `boolean` | `hasBlockRecorder()`
    `` | `void` | `init(VariableScope el, Parameter[] parameters)` initializes this class for a MethodNode.
    `` | `boolean` | `isImplicitThis()`
    `` | `boolean` | `isInSpecialConstructorCall()`
    `` | `boolean` | `isLHS()`
    `` | `void` | `pop()`
    `` | `void` | `popBlockRecorderVisit(BlockRecorder finallyBlock)`
    `` | `void` | `popImplicitThis()`
    `` | `void` | `popLHS()`
    `` | `void` | `pushBlockRecorder(BlockRecorder recorder)`
    `` | `void` | `pushBlockRecorderVisit(BlockRecorder finallyBlock)`
    `` | `void` | `pushBooleanExpression()` because a boolean Expression may not be evaluated completely it is important to keep the registers clean
    `` | `void` | `pushImplicitThis(boolean implicitThis)`
    `` | `void` | `pushInSpecialConstructorCall()`
    `` | `void` | `pushLHS(boolean lhs)`
    `` | `void` | `pushLoop(VariableScope el, String labelName)` Should be called when descending into a loop that defines also a scope.
    `` | `void` | `pushLoop(VariableScope el, List<String> labelNames)` Should be called when descending into a loop that defines also a scope.
    `` | `void` | `pushLoop(String labelName)` Should be called when descending into a loop that does not define a scope.
    `` | `void` | `pushLoop(List<String> labelNames)` Should be called when descending into a loop that does not define a scope.
    `` | `void` | `pushState()`
    `` | `org.objectweb.asm.Label` | `pushSwitch()` Creates a new break label and a element for the state stack so pop has to be called later
    `` | `void` | `pushVariableScope(VariableScope el)` Causes the state-stack to add an element and sets the given scope as new current variable scope.
    `` | `void` | `removeVar(int tempIndex)`
    `` | `void` | `writeExceptionTable(BlockRecorder block, org.objectweb.asm.Label goal, String sig)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### public def CompileStack(WriterController wc)

    - #### public void addExceptionBlock(org.objectweb.asm.Label start, org.objectweb.asm.Label end, org.objectweb.asm.Label goal, String sig)

    - #### public void applyBlockRecorder()

    - #### public void applyFinallyBlocks(org.objectweb.asm.Label label, boolean isBreakLabel)

    - #### public void clear()

      Clears the state of the class. This method should be called after a MethodNode is visited. Note that a call to init will fail if clear is not called before

    - #### public boolean containsVariable(String name)

      Parameters:
        `name` - the name of the variable of interest
      Returns:
        true if a variable is already defined

    - #### public org.objectweb.asm.Label createLocalLabel(String name)

      creates a new named label

    - #### public int defineTemporaryVariable(Variable var, boolean store)

      creates a temporary variable.

      Parameters:
        `var` - defines type and name
        `store` - defines if the toplevel argument of the stack should be stored
      Returns:
        the index used for this temporary variable

    - #### public int defineTemporaryVariable(String name, boolean store)

      creates a temporary variable.

      Parameters:
        `name` - defines type and name
        `store` - defines if the top-level argument of the stack should be stored
      Returns:
        the index used for this temporary variable

    - #### public int defineTemporaryVariable(String name, ClassNode node, boolean store)

      creates a temporary variable.

      Parameters:
        `name` - defines the name
        `node` - defines the node
        `store` - defines if the top-level argument of the stack should be stored
      Returns:
        the index used for this temporary variable

    - #### public BytecodeVariable defineVariable(Variable v, boolean initFromStack)

      Defines a new Variable using an AST variable.

      Parameters:
        `initFromStack` - if true the last element of the stack will be used to initialize the new variable. If false null will be used.

    - #### public BytecodeVariable defineVariable(Variable v, ClassNode variableType, boolean initFromStack)

    - #### public org.objectweb.asm.Label getBreakLabel()

    - #### public org.objectweb.asm.Label getContinueLabel()

    - #### public org.objectweb.asm.Label getLabel(String name)

      Returns the label for the given name

    - #### public org.objectweb.asm.Label getNamedBreakLabel(String name)

      Used for `break foo` inside a loop to end the execution of the marked loop. This method will return the break label of the loop if there is one found for the name. If not, the current break label is returned.

    - #### public org.objectweb.asm.Label getNamedContinueLabel(String name)

      Used for `continue foo` inside a loop to continue the execution of the marked loop. This method will return the break label of the loop if there is one found for the name. If not, getLabel is used.

    - #### public VariableScope getScope()

    - #### public BytecodeVariable getVariable(String variableName)

    - #### public BytecodeVariable getVariable(String variableName, boolean mustExist)

      Returns a normal variable.

      If `mustExist` is true and the normal variable doesn't exist, then this method will throw a GroovyBugError. It is not the intention of this method to let this happen! And the exception should not be used for flow control - it is just acting as an assertion. If the exception is thrown then it indicates a bug in the class using CompileStack. This method can also not be used to return a temporary variable. Temporary variables are not normal variables.

      Parameters:
        `variableName` - name of the variable
        `mustExist` - throw exception if variable does not exist
      Returns:
        the normal variable or null if not found (and `mustExist` not true)

    - #### public boolean hasBlockRecorder()

    - #### public void init(VariableScope el, Parameter[] parameters)

      initializes this class for a MethodNode. This method will automatically define variables for the method parameters and will create references if needed. The created variables can be accessed by calling getVariable().

    - #### public boolean isImplicitThis()

    - #### public boolean isInSpecialConstructorCall()

    - #### public boolean isLHS()

    - #### public void pop()

    - #### public void popBlockRecorderVisit(BlockRecorder finallyBlock)

    - #### public void popImplicitThis()

    - #### public void popLHS()

    - #### public void pushBlockRecorder(BlockRecorder recorder)

    - #### public void pushBlockRecorderVisit(BlockRecorder finallyBlock)

    - #### public void pushBooleanExpression()

      because a boolean Expression may not be evaluated completely it is important to keep the registers clean

    - #### public void pushImplicitThis(boolean implicitThis)

    - #### public void pushInSpecialConstructorCall()

    - #### public void pushLHS(boolean lhs)

    - #### public void pushLoop(VariableScope el, String labelName)

      Should be called when descending into a loop that defines also a scope. Calls pushVariableScope and prepares labels for a loop structure. Creates a element for the state stack so pop has to be called later, TODO:

      Deprecate:

    - #### public void pushLoop(VariableScope el, List<String> labelNames)

      Should be called when descending into a loop that defines also a scope. Calls pushVariableScope and prepares labels for a loop structure. Creates a element for the state stack so pop has to be called later

    - #### public void pushLoop(String labelName)

      Should be called when descending into a loop that does not define a scope. Creates a element for the state stack so pop has to be called later, TODO:

      Deprecate:

    - #### public void pushLoop(List<String> labelNames)

      Should be called when descending into a loop that does not define a scope. Creates a element for the state stack so pop has to be called later

    - #### public void pushState()

    - #### public org.objectweb.asm.Label pushSwitch()

      Creates a new break label and a element for the state stack so pop has to be called later

    - #### public void pushVariableScope(VariableScope el)

      Causes the state-stack to add an element and sets the given scope as new current variable scope. Creates a element for the state stack so pop has to be called later

    - #### public void removeVar(int tempIndex)

    - #### public void writeExceptionTable(BlockRecorder block, org.objectweb.asm.Label goal, String sig)